1. 1


| |
| --- |


extractor
  1. 1.1FvExtractor

Extracts/proccesses data from a TUFLOW FV netCDF4 files into ready to use formats

Class tfv\_tools.extractor.FvExtractor(file, is\_spherical=True)

**Parameters**

file (String): File path to TUFLOW FV netCDF4 results file

is\_spherical (bool): Is the model result file defined in a spherical coordinate reference system

**Attributes**

nc (object): netCDF4.Dataset object for TUFLOW FV netCDF4 results file

nt (integer): Number of model time steps

nc2 (integer): Number of 2D mesh cell/elements

nc3 (integer): Number of 3D mesh cell/elements

time\_vector (array): Model result output time as python time stamp array

node\_x (array): A (nc2,) array defining the x-coordinate of the 2D model mesh cell/element vertices

node\_y (array): A (nc2,) array defining the y-coordinate of the 2D model mesh cell/element vertices

cell\_node (array): A (nc2, 4) array defining each 2D model mesh cell/element by four node indices

is\_tri (array): A (nc2,) logical array, true if 2D model mesh cell is triangular

is\_quad (array): A (nc2,) logical array, true if 2D model mesh cell is quadrilateral

nz (array): A (nc2,) array defining number of vertical cells in each 2D model mesh cell

idx2 (array): A (nc3,) array defining the 2D model mesh cell index for each 3D cell

idx3 (array): A (nc2,) array defining the surface 3D model mesh cell index for each 2D model mesh cell

idx4 (array): A (nc3+nc2,) array defining the 2D model mesh cell index for each 3D vertical layer face

wli (array): A (nc2,) array defining the surface vertical layer face index for each 2D model mesh cell

bli (array): A (nc2,) array defining the bed vertical layer face index for each 2D model mesh cell

**Methods**

get\_raw\_data(self, variable, ii)

Return the raw data for given variable at i
# th
 time step

get\_stat\_vector(self, ii)

Return the stat vector at i
# th
 time step

get\_z\_layer\_faces(self, ii)

Return the 3D model mesh vertical layer faces at ith time step



get\_sheet\_cell(self, variable, ii, datum, limits)

Return depth-averaged data in a 2D map format (&#39;sheet&#39;) at model cell centroids at i
# th
 time step

get\_sheet\_node(self, variable, ii, datum, limits)

Return depth-averaged data in a 2D map format (&#39;sheet&#39;) at model cell vertices at i
# th
 time step

get\_sheet\_grid(self, variable, ii, grid\_x, grid\_y, datum, limits)

Return depth-averaged data in a 2D map format (&#39;sheet&#39;) at grid points at i
# th
 time step

get\_curtain\_cell(self, variable, ii, polyline)

Return data in a vertical slice format (&#39;curtain&#39;) at the cell centroids at i
# th
 time step

get\_curtain\_grid(self, variable, ii, polyline, grid\_x, grid\_y)

Return data in a vertical slice format (&#39;curtain&#39;) at grid points at i
# th
 time step

get\_profile\_cell(self, variable, ii, point)

Return data in a 1D vertical profile at cell centroids at ith time step

write\_time\_series\_file(self, out\_file, locations)

Writes 2D &amp; 3D point time series data from a TUFLOW FV netCDF4 results file

write\_data\_to\_ascii(self, out\_file, data, resolution)

Writes model cell centroid data to gridded raster ASCII file

1. 2timeseries
  1. 2.1FvTimeSeries

Extracts data from a TUFLOW FV &#39;profiles&#39; or &#39;time series&#39; netCDF4 file.

Class tfv\_tools.extractor.FvTimeSeries(file)

**Parameters**

file (String): File path to time series file written by FvExtractor.write\_time\_series\_file

**Attributes**

nc (object): netCDF4.Dataset object for TUFLOW FV netCDF4 time series file

nt (integer): Number of model time steps

time\_vector (array): Model result output time as python time stamp array

locations (dict): Site map for point time series locations {name: [x, y]}

**Methods**

get\_raw\_data(self, variable, site)

Return the raw time series data for given variable at given site/location

get\_stat\_vector(self, site)

Return the stat vector at given site/location

get\_z\_layer\_faces(self, site)

Return the 3D model cell vertical layer faces at given site/location

get\_data(self, variable, site, datum, limits)

Return depth-averaged time series data for given variable at given site/location

1. 3Visual
  1. 3.1Slider

A slider bar graphics object which fires registered call backs when updated

Class tfv\_tools.visual.Slider(figure, values, callbacks=[], init\_value=None)

**Parameters**

figure (object): matplotlib.pyplot.Figure object to hold/display slider bar

values (array): An array of valid slider values

callbacks (list): A list of functions which will be called with the current slider value as the only argument

init\_value (float): Initial slider bar value



1.
  1. 3.2Viewer

An object which manages dynamic viewing of time updateable graphics objects

Class tfv\_tools.visual.Viewer(size=(240, 200), units=&#39;mm&#39;, time\_fmt= &#39;%d/%m/%Y %H:%M:%S&#39;)

**Parameters**

size (tuple): Size of underlying figure as (width, height) in specified units

units (string): Figure units i.e. &#39;mm&#39;, &#39;cm&#39; or &#39;m&#39;

time\_fmt (string): Time format of title based on python datetime string formatting conventions

**Attributes**

figure (object): Underlying matplotlib.pyplot.Figure object which renders/displays graphics objects

title (object): The matplotlib.text.Text graphics object for the figure title

time\_vector (array): Viewer time as python time stamp array

time\_current (float): Time currently being displayed by Viewer as python time stamp

**Methods**

print(out\_file, fmt=&#39;png&#39;, dpi=300)

Prints displayed figure to image file

animate(out\_file, ts, te, dt, fps=10, dpi=150)

Writes animation of viewer based on time start &amp; time end

1.
  1. 3.3SheetPatch

A dynamic patch collection graphics object for viewing model result data in plan view as &#39;sheet&#39;

Class tfv\_tools.visual.SheetPatch(axes, extractor, expression, datum=&#39;sigma&#39;, limits=(0, 1), \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.extractor.Extractor object which extracts the data

expression (string): The variable name or expression which will be extracted and displayed

datum (string): Depth averaging datum (reference frame) i.e &#39;sigma&#39;, &#39;depth&#39;, &#39;height&#39;, &#39;elevation&#39;

limits (tuple): The vertical limits over which to depth average, limits defined with respect to datum

**Other Parameters (\*\*kwargs)** - matplotlib.collections.PatchCollection Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

shading (string): Sets the shading to be flat or interpolated (gourad) i.e &#39;flat&#39; or &#39;interp&#39;

cmap (object): Colour map as matplotlib.colors.LinearSegmentedColormap object

clim (tuple): Colour limits of the underlying matplotlib.collections.PatchCollection object (min, max)

norm (object): Normalization object as matplotlib.colors.Normalize or matplotlib.colors.BoundaryNorm

edgecolor (string): Sets the mesh edge colouring of the underlying matplotlib.collections object

antialiased (bool): Sets the antialiasing state for rendering the underlying matplotlib.collections object

alpha (float): Sets the transparencies of the underlying matplotlib.collections object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

patch (object): The underlying matplotlib.collections object (PatchCollection or TriMesh)

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object

1.
  1. 3.4SheetContour

A dynamic contour graphics object for viewing model result data in plan view as &#39;sheet&#39;

Class tfv\_tools.visual.SheetContour(axes, extractor, expression, datum=&#39;sigma&#39;, limits=(0, 1), \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.extractor.Extractor object which extracts the data

expression (string): The variable name or expression which will be extracted and displayed

datum (string): Depth averaging datum (reference frame) i.e &#39;sigma&#39;, &#39;depth&#39;, &#39;height&#39;, &#39;elevation&#39;

limits (tuple): The vertical limits over which to depth average, limits defined with respect to datum

**Other Parameters (\*\*kwargs)** - matplotlib.tri.TriContourSet Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

cmap (object): Colour map as matplotlib.colors.LinearSegmentedColormap object

clim (tuple): Colour limits of the underlying matplotlib.tri.TriContourSet object (min, max)

norm (object): Normalization object as matplotlib.colors.Normalize or matplotlib.colors.BoundaryNorm

levels (integer or array): Contour levels as number of intervals/bins or array defining the intervals

antialiased (bool): Sets the antialiasing for rendering the underlying matplotlib.tri.TriContourSet object

alpha (float): Sets the transparencies of the underlying matplotlib.tri.TriContourSet object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

cont (object): The underlying matplotlib.tri.TriContourSet object

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object

1.
  1. 3.5SheetVector

A dynamic quiver graphics object for viewing model result data in plan view as &#39;sheet&#39;

Class tfv\_tools.visual.SheetVector(axes, extractor, expression, datum=&#39;sigma&#39;, limits=(0, 1), \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.extractor.Extractor object which extracts the data

expression (string): The variable name or expression which will be extracted and displayed

datum (string): Depth averaging datum (reference frame) i.e &#39;sigma&#39;, &#39;depth&#39;, &#39;height&#39;, &#39;elevation&#39;

limits (tuple): The vertical limits over which to depth average, limits defined with respect to datum

resolution (integer): Vector field resolution as number of arrows

**Other Parameters (\*\*kwargs)** - matplotlib.quiver.Quiver Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

units (string): Arrow dimensions (except length) i.e width are in this unit

scale\_units (string): Arrow length dimension is in this unit

scale (float): Number of data units per arrow length i.e  scale=1/10 is  10 arrow unit/data unit

width (float): Shaft width of the arrow in arrow units

headwidth (float): Head width as multiple of the shaft width

headlength(float): Head length as multiple of shaft length

angles (string): Method to determine angles of the arrow

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

quiver (object): The underlying matplotlib.quiver.Quiver object

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object

1.
  1. 3.6CurtainPatch

A dynamic patch collection graphics object for viewing model result data in elevation view as &#39;curtain&#39;

Class tfv\_tools.visual.CurtainPatch(axes, extractor, expression, polyline, \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.extractor.Extractor object which extracts the data

expression (string): The variable name or expression which will be extracted and displayed

polyline (array): Polyline as (n, 2) array of [x, y] coordinates used to slice 3D data.

**Other Parameters (\*\*kwargs)** - matplotlib.collections.PatchCollection Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

shading (string): Sets the shading to be flat or interpolated (gourad) i.e &#39;flat&#39; or &#39;interp&#39;

cmap (object): Colour map as matplotlib.colors.LinearSegmentedColormap object

clim (tuple): Colour limits of the underlying matplotlib.collections.PatchCollection object (min, max)

norm (object): Normalization object as matplotlib.colors.Normalize or matplotlib.colors.BoundaryNorm

edgecolor (string): Sets the mesh edge colouring of the underlying matplotlib.collections object

antialiased (bool): Sets the antialiasing state for rendering the underlying matplotlib.collections object

alpha (float): Sets the transparencies of the underlying matplotlib.collections object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

patch (object): The underlying matplotlib.collections object (PatchCollection or TriMesh)

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object

1.
  1. 3.7CurtainVector

A dynamic quiver graphics object for viewing model result data in elevation view as &#39;curtain&#39;

Class tfv\_tools.visual.CurtainVector(axes, extractor, expression, polyline, \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.extractor.Extractor object which extracts the data

expression (string): The variable name or expression which will be extracted and displayed

polyline (array): Polyline as (n, 2) array of [x, y] coordinates used to slice 3D data.

resolution (integer): Vector field resolution as number of arrows

**Other Parameters (\*\*kwargs)** - matplotlib.quiver.Quiver Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

units (string): Arrow dimensions (except length) i.e width are in this unit

scale\_units (string): Arrow length dimension is in this unit, &#39;xy&#39; or &#39;uv&#39;

scale (float): Number of data units per arrow length i.e  scale=1/10 is  10 arrow unit/data unit

width (float): Shaft width of the arrow in arrow units

headwidth (float): Head width as multiple of the shaft width

headlength(float): Head length as multiple of shaft length

angles (string): Method to determine angles of the arrow

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

quiver (object): The underlying matplotlib.quiver.Quiver object

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object

1.
  1. 3.8ProfileCell

A dynamic line graphics object for visualizing model result data as profile at a point

Class tfv\_tools.visual.ProfileCell(axes, extractor, expression, point, \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.extractor.Extractor object which extracts the data

expression (string): The variable name or expression which will be extracted and displayed

point (tuple): Point as (x, y) coordinates at which to extract profile.

**Other Parameters (\*\*kwargs)** – matplotlib.lines.Line2D Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

linestyle (string): Sets the linestyle of the underlying matplotlib.lines.line2D object

linewidth (float): Sets the linewidth of the underlying matplotlib.lines.line2D object

color (string): Sets the color of the underlying matplotlib.lines.line2D object

alpha (float): Sets the transparency of the underlying matplotlib.lines.line2D object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

**Methods**

zoom(self):

Sets the parent axes extent to cover the graphics object





1.
  1. 3.9SeriesGlider

A dynamic line object which glides along a plotted time series, marking the current time of the viewer

Class tfv\_tools.visual.SeriesGlider(axes, extractor, expression, location)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.timeseries.TimeSeries object which extracts the time series data

expression (string): The variable name or expression which will be extracted and displayed as time series

location (string): Name of point time series location stored in time series file.

**Other Parameters (\*\*kwargs)** – matplotlib.lines.Line2D Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

linestyle (string): Sets the linestyle of the underlying matplotlib.lines.line2D object

linewidth (float): Sets the linewidth of the underlying matplotlib.lines.line2D object

color (string): Sets the color of the underlying matplotlib.lines.line2D object

alpha (float): Sets the transparency of the underlying matplotlib.lines.line2D object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

line (object): The underlying matplotlib.lines.Line2D graphics object

**Methods**

zoom(self):

Sets the parent axes extent to cover the graphics object



1.
  1. 3.10HovmollerGlider

A dynamic line object which glides along a plotted Hovmoller diagram, marking the current time of the viewer

Class tfv\_tools.visual.HovmollerGlider(axes, extractor, expression, location)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (object): The tfv\_tools.timeseries.TimeSeries object which extracts the time series data

expression (string): The variable name or expression which will be extracted and displayed as time series

location (string): Name of point time series location stored in time series file.

**Other Parameters (\*\*kwargs)** – matplotlib.collections.PatchCollection Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

shading (string): Sets the shading to be flat or interpolated (gourad) i.e &#39;flat&#39; or &#39;interp&#39;

cmap (object): Colour map as matplotlib.colors.LinearSegmentedColormap object

clim (tuple): Colour limits of the underlying matplotlib.collections.PatchCollection object (min, max)

norm (object): Normalization object as matplotlib.colors.Normalize or matplotlib.colors.BoundaryNorm

edgecolor (string): Sets the mesh edge colouring of the underlying matplotlib.collections object

antialiased (bool): Sets the antialiasing state for rendering the underlying matplotlib.collections object

alpha (float): Sets the transparencies of the underlying matplotlib.collections object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

patch (object): The underlying matplotlib.collections object (PatchCollection or TriMesh)

**Methods**

zoom(self):

Sets the parent axes extent to cover the graphics object

1.
  1. 3.11DeltaSheetPatch

A dynamic patch collection graphics object for viewing difference in model results in plan view as &#39;sheet&#39;

Class tfv\_tools.visual.DeltaSheetPatch(axes, extractor, expression, datum=&#39;sigma&#39;, limits=(0, 1), \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (tuple): A tuple of tfv\_tools.extractor.Extractor which to calculated difference from (base, developed)

expression (string): The variable name or expression which will be extracted and displayed

datum (string): Depth averaging datum (reference frame) i.e &#39;sigma&#39;, &#39;depth&#39;, &#39;height&#39;, &#39;elevation&#39;

limits (tuple): The vertical limits over which to depth average, limits defined with respect to datum

**Other Parameters (\*\*kwargs)** - matplotlib.collections.PatchCollection Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

shading (string): Sets the shading to be flat or interpolated (gourad) i.e &#39;flat&#39; or &#39;interp&#39;

cmap (object): Colour map as matplotlib.colors.LinearSegmentedColormap object

clim (tuple): Colour limits of the underlying matplotlib.collections.PatchCollection object (min, max)

norm (object): Normalization object as matplotlib.colors.Normalize or matplotlib.colors.BoundaryNorm

edgecolor (string): Sets the mesh edge colouring of the underlying matplotlib.collections object

antialiased (bool): Sets the antialiasing state for rendering the underlying matplotlib.collections object

alpha (float): Sets the transparencies of the underlying matplotlib.collections object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

patch (object): The underlying matplotlib.collections object (PatchCollection or TriMesh)

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object



1.
  1. 3.12DeltaSheetContour

A dynamic contour graphics object for viewing difference in model results in plan view as &#39;sheet&#39;

Class tfv\_tools.visual.DeltaSheetContour(axes, extractor, expression, datum=&#39;sigma&#39;, limits=(0, 1), \*\*kwargs)

**Parameters**

axes (object): The matplotlib.pyplot.Axes object to display/render the graphics object

extractor (tuple): A tuple of tfv\_tools.extractor.Extractor which to calculated difference from (base, developed)

expression (string): The variable name or expression which will be extracted and displayed

datum (string): Depth averaging datum (reference frame) i.e &#39;sigma&#39;, &#39;depth&#39;, &#39;height&#39;, &#39;elevation&#39;

limits (tuple): The vertical limits over which to depth average, limits defined with respect to datum

**Other Parameters (\*\*kwargs)** - matplotlib.tri.TriContourSet Properties

zorder (integer): Layer order in which graphics object will be rendered (0 is bottom/first)

cmap (object): Colour map as matplotlib.colors.LinearSegmentedColormap object

clim (tuple): Colour limits of the underlying matplotlib.tri.TriContourSet object (min, max)

norm (object): Normalization object as matplotlib.colors.Normalize or matplotlib.colors.BoundaryNorm

levels (integer or array): Contour levels as number of intervals/bins or array defining the intervals

antialiased (bool): Sets the antialiasing for rendering the underlying matplotlib.tri.TriContourSet object

alpha (float): Sets the transparencies of the underlying matplotlib.tri.TriContourSet object

**Attributes**

time\_vector (array): Model result output time as python time stamp array

expression (object): The tfv\_tools.misc.Expression object which handles custom data extraction and display

viewer (object): The tfv\_tools.visual.Viewer object which is displaying the Visual object

cont (object): The underlying matplotlib.tri.TriContourSet object

**Methods**
zoom(self):

Sets the parent axes extent to cover the graphics object