# Import modules, functions & classes
from tfv.extractor import FvExtractor

# ---------------------------------------------------- Input -----------------------------------------------------------

# Result file folder and names from which time series are being extracted
res_folder = r'ADD THE PATH TO YOUR RESULTS HERE\results'

res_names = \
    [
        r'HYD_000.nc',
        r'HYD_001.nc',
        r'HYD_002.nc',
    ]

# locations at which time series are being extracted
site_map = {'Point_1' : [159.0758, -31.3638],
            'Point_2' : [159.0845,  -31.3727],
            'Point_3' : [159.0906,  -31.3814],
            'Point_4' : [159.1001,  -31.3948],
            'Point_5' : [159.1154,  -31.4032],
            'Point_6' : [159.1266,  -31.4105],
            'Point_7' : [159.1202,  -31.4165],
            'Point_8' : [159.1178,  -31.4236],
            'Point_9' : [159.1277,  -31.4402]}

# ---------------------------------------------------- Script ----------------------------------------------------------
for res_name in res_names:
    res_file = res_folder + '\\' + res_name
    out_file = res_file.replace('.nc', '_time_series.nc')
    FvExtractor(res_file).write_time_series_file(out_file, site_map)
